'''
Script Features :: List

1) Admin Controlled
2) Headshot Mode
3) Deathmatch Mode
4) War Mode
5) Extras Mode:
    - NoScope ONLY
    - Knife ONLY
    - ONE Shot Kill
'''

'''
Information :: Script Header
'''

import es, gamethread, playerlib, popuplib, random

info = es.AddonInfo()
info.name          = 'scoutzKnivez'
info.basename      = 'scoutzKnivez'
info.version       = '1.0'
info.author        = '-Adz. #Gr'
info.description   = 'All in 1 ScoutzKnivez script'

'''
Global Scope :: Configuration
'''

adminList = ['STEAM_0:1:14196281', 'STEAM_0:1:17243170', 'STEAM_0:1:8491429', 'STEAM_0:1:18991171']
defaultPassword = 'grWar'
defaultGravity = 220

options = ('Swap', 'Kick', 'Ban')
filters = ('Player', 'Team', 'All')
clientList = []
gravityList = []
changePasswordUser = []
commandList = ['admin', 'swap']
adminOptions = ['Headshot', 'Deathmatch', 'Knife Only', 'One Shot', 'No Scope']
spawnList = ['63.351428 -607.767944 -615.968750', '412.031250 -732.031250 -615.968750', '-3.493362 -919.878845 -455.968750', '-227.968750 -864.450134 -455.968750', '358.385955 129.917510 -471.968750', '534.487426 -886.564880 -327.968750', '582.674926 373.855621 -199.968750', '620.600891 583.149780 -71.968750', '357.200439 845.205017 -199.968750', '-133.784164 883.855712 -351.968750', '-55.606693 917.603820 -487.968750', '-277.702514 947.968750 -615.968750', '150.305587 917.990661 -615.968750', '-730.466125 -258.898529 -455.968750', '-695.475646 179.968750 -359.968750', '-738.695129 332.005096 -199.968750', '-752.229797 676.592163 -231.968750', '-480.671966 -898.958740 -119.968750', '-664.530944 -881.456604 56.031250', '-340.660919 -81.494049 -327.968750', '-243.968750 49.521057 -327.968750']

'''
Necessary Scope :: Declarations
'''

def msg(text):
    es.msg('#multi', '#greenScoutzKnivez #default~ ', text)
    
def tell(userid, text):
    es.tell(userid, '#multi', '#greenScoutzKnivez #default~ ', text)

def load():
    global adminMenuTop, adminMenu, adminMenuOption, adminMenuAdmin, adminMenuCommands, deathmatch, headshot, knifeOnly, oneShot, noScope, warMode, publicChat
    msg('Has been LOADED')
    deathmatch = 0
    headshot = 0
    knifeOnly = 0
    oneShot = 0
    noScope = 0
    warMode = 0
    publicChat = 1
    for sayCommand in commandList:
        if not es.exists('command', sayCommand):
            es.regsaycmd('!%s' % sayCommand, 'scoutzKnivez/%sCmd' % sayCommand)
    es.addons.registerSayFilter(sayFilter)
    adminMenuTop = popuplib.easymenu('adminMenuTop', None, adminMenuTopSelect)
    adminMenuTop.settitle('ScoutzKnivez #GlobalRebellion')
    adminMenuTop.setdescription(':: Admin')
    adminMenuTop.addoption(1, 'Manage Players')
    adminMenuTop.addoption(2, 'Server Modes')
    adminMenuTop.addoption(3, 'Server Commands')
    adminMenuTop.addoption(4, 'Update Admins')
    adminMenuOption = popuplib.easymenu('adminMenuOption', None, adminMenuOptionSelect)
    adminMenuOption.settitle('ScoutzKnivez #GlobalRebellion')
    adminMenuOption.setdescription(':: Actions')
    for option in options:
        adminMenuOption.addoption(option, option)
    adminMenu = popuplib.easymenu('adminMenu', None, adminMenuSelect)
    adminMenu.settitle('ScoutzKnivez #GlobalRebellion')
    adminMenu.setdescription(':: Modes')
    adminMenu.addoption(1, 'Toggle Deathmatch')
    adminMenu.addoption(2, 'Toggle Headshot')
    adminMenu.addoption(3, 'Toggle Knife Only')
    adminMenu.addoption(4, 'Toggle No Scope Only')
    adminMenu.addoption(5, 'Toggle One Shot Kill')
    adminMenu.addoption(6, 'Toggle War Mode')
    adminMenuAdmin = popuplib.easymenu('adminMenuAdmin', None, adminMenuAdminSelect)
    adminMenuAdmin.settitle('ScoutzKnivez #GlobalRebellion')
    adminMenuAdmin.setdescription(':: Admins')
    adminMenuAdmin.addoption(1, 'Add a Client')
    adminMenuAdmin.addoption(2, 'Remove a Client')
    adminMenuAdmin.addoption(3, 'Display a Client')
    adminMenuCommands = popuplib.easymenu('adminMenuCommands', None, adminMenuCommandsSelect)
    adminMenuCommands.settitle('ScoutzKnivez #GlobalRebellion')
    adminMenuCommands.setdescription(':: Commands')
    adminMenuCommands.addoption(1, 'Gravity - %s' % defaultGravity)
    adminMenuCommands.addoption(2, 'Toggle Public Chat')
    adminMenuCommands.addoption(3, 'Password Server')
    
def unload():
    msg('Has been UNLOADED')
    for sayCommand in commandList:
        if es.exists('command', sayCommand):
            es.unregsaycmd('!%s' % sayCommand)
    es.addons.unregisterSayFilter(sayFilter)
    adminMenu.delete()
    adminMenuTop.delete()
    adminMenuOption.delete()
    adminMenuAdmin.delete()
    adminMenuCommands.delete()
    del clientList[:]
    del gravityList[:]
    del changePasswordUser[:]
  
'''
Custom Scope :: Functions
'''

def adminCmd():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    if steamid in adminList:
        adminMenuTop.send(userid)
    else:
        tell(userid, 'Your not ADMIN')
        
def swapCmd():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    team = es.getplayerteam(userid)
    if steamid in adminList:
        msg('Half time and swapping TEAMS')
        gamethread.delayed(2, es.changeteam, (userid, getOpponentTeam(team)))
        gamethread.delayed(5, liveOnThree)
    else:
        tell(userid, 'Your not ADMIN')
        
def getOpponentTeam(team):
    if team == 2:
        return 3
    elif team == 3:
        return 2
    else:
        return 1

def headshotOn(userid):
    global headshot
    headshot = 1
    msg('Headshot Mode has been ENABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    
def headshotOff(userid):
    global headshot
    headshot = 0
    msg('Headshot Mode has been DISABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    
def deathmatchOn(userid):
    global deathmatch
    deathmatch = 1
    msg('Deathmatch Mode has been ENABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    
def deathmatchOff(userid):
    global deathmatch
    deathmatch = 0
    msg('Deathmatch Mode has been DISABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    
def oneShotOn(userid):
    global oneShot
    oneShot = 1
    msg('One Shot Kill Mode has been ENABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    
def oneShotOff(userid):
    global oneShot
    oneShot = 0
    msg('One Shot Kill Mode has been DISABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    
def noScopeOn(userid):
    global noScope
    noScope = 1
    msg('No Scope Only Mode has been ENABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    
def noScopeOff(userid):
    global noScope
    noScope = 0
    msg('No Scope Only Mode has been DISABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    
def knifeOnlyOn(userid):
    global knifeOnly
    knifeOnly = 1
    msg('Knife Only Mode has been ENABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    
def knifeOnlyOff(userid):
    global knifeOnly
    knifeOnly = 0
    msg('Knife Only Mode has been DISABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    
def warModeOn(userid):
    global clientMenu
    global warMode
    steamid = es.getplayersteamid(userid)
    warMode = 1
    msg('War Mode has been ENABLED')
    msg('Round will be RESTARTED')
    msg('War will commence in 30 seconds')
    tell(userid, '#lightgreenPlease kick unwanted players and sort teams')
    gamethread.delayed(10, msg, ('War will commence in 20 seconds'))
    gamethread.delayed(20, msg, ('War will commence in 10 seconds'))
    gamethread.delayed(25, msg, ('War will commence in 5 seconds'))
    gamethread.delayed(30, es.server.queuecmd, ('sv_password %s' % defaultPassword))
    gamethread.delayed(30, es.server.queuecmd, ('sv_alltalk 0'))
    gamethread.delayed(30, es.server.queuecmd, ('mp_forcecamera 1'))
    gamethread.delayed(30, es.server.queuecmd, ('sv_airaccelerate 10000'))
    gamethread.delayed(30, es.server.queuecmd, ('sv_wateraccelerate 10000'))
    gamethread.delayed(32, tell, (userid, '#lightgreenType in a numeric value for Gravity'))
    gamethread.delayed(32, gravityList.append, (steamid))
    
def warModeOff(userid):
    global warMode
    warMode = 0
    msg('War Mode has been DISABLED')
    msg('Round will be RESTARTED')
    es.server.queuecmd('mp_restartgame 1')
    es.server.queuecmd('sv_password ""')
    msg('Server password has been REMOVED')
    es.server.queuecmd('exec server.cfg')
    
def liveOnThree():
    if es.ServerVar('tv_enable') == 1:
        es.server.queuecmd('tv_record %s_%s.dem' %(es.ServerVar('eventscripts_currentmap'), time.strftime('%d-%m-%Y_%M:%H:%S')))
        msg('Recording %s_%s.dem' %(es.ServerVar('eventscripts_currentmap'), time.strftime('%d-%m-%Y_%M:%H:%S')))
    msg('Live on 3 Restarts')
    gamethread.delayed(1, es.server.queuecmd, ('mp_restartgame 1'))
    gamethread.delayed(2, msg, ('Live on 2 Restarts'))
    gamethread.delayed(2, es.server.queuecmd, ('mp_restartgame 1'))
    gamethread.delayed(4, msg, ('Live After Next Restart'))
    gamethread.delayed(4, es.server.queuecmd, ('mp_restartgame 1'))
    gamethread.delayed(6, msg, ('Match is Live'))
    gamethread.delayed(6, msg, ('Match is Live'))
    gamethread.delayed(6, msg, ('Match is Live'))
    gamethread.delayed(6, msg, ('[G]ood [L]uck & [H]ave [F]un'))
    gamethread.delayed(6, msg, ('"http://GlobalRebellion.co.uk"'))
    
'''
Select Scope :: Controlling Popups
'''

def adminMenuTopSelect(userid, choice, popupname):
    if choice == 1:
        adminMenuOption.send(userid)
    elif choice == 2:
        adminMenu.send(userid)
    elif choice == 3:
        adminMenuCommands.send(userid)
    elif choice == 4:
        adminMenuAdmin.send(userid)

def adminMenuSelect(userid, choice, popupname):
    global deathmatch, headshot, knifeOnly, noScope, oneShot, warMode
    if choice == 1:
        if deathmatch == 1:
            deathmatchOff(userid)
        elif deathmatch == 0:
            deathmatchOn(userid)
    elif choice == 2:
        if headshot == 1:
            headshotOff(userid)
        elif headshot == 0:
            headshotOn(userid)
    elif choice == 3:
        if knifeOnly == 1:
            knifeOnlyOff(userid)
        elif knifeOnly == 0:
            knifeOnlyOn(userid)
    elif choice == 4:
        if noScope == 1:
            noScopeOff(userid)
        elif noScope == 0:
            noScopeOn(userid)
    elif choice == 5:
        if oneShot == 1:
            oneShotOff(userid)
        elif oneShot == 0:
            oneShotOn(userid)
    elif choice == 6:
        if warMode == 1:
            warModeOff(userid)
        elif warMode == 0:
            warModeOn(userid)
                
def adminMenuOptionSelect(userid, choice, popupname):
    global adminMenuFilters
    adminMenuFilters = popuplib.easymenu('adminMenuFilters', None, adminMenuFiltersSelect)
    adminMenuFilters.settitle('War #GlobalRebellion')
    adminMenuFilters.setdescription(':: Filters')
    for filter in filters:
        adminMenuFilters.addoption('%s_%s' % (choice, filter), '%s %s' % (choice, filter))
    adminMenuFilters.send(userid)
    
def adminMenuFiltersSelect(userid, choice, popupname):
    choice = choice.split('_', 1)
    exec('%s(%s, "%s")' % (choice[1], userid, choice[0]))
    
def Player(userid, choice):
    global adminMenuPlayers
    adminMenuPlayers = popuplib.easymenu('adminMenuPlayers', None, adminMenuPlayersSelect)
    adminMenuPlayers.settitle('War #GlobalRebellion')
    adminMenuPlayers.settitle("%s a Player:" % choice)
    for players in es.getUseridList():
        adminMenuPlayers.addoption('%s_%s' % (choice, players), es.getplayername(players))
    adminMenuPlayers.send(userid)

def Team(userid, choice):
    global adminMenuTeam
    adminMenuTeam = popuplib.easymenu('adminMenuTeam', None, adminMenuTeamSelect)
    adminMenuTeam.settitle("%s a team:" % choice)
    adminMenuTeam.addoption('%s_2' % choice, '%s Terrorists' % choice)
    adminMenuTeam.addoption('%s_3' % choice, '%s Counter-Terrorists' % choice)
    adminMenuTeam.addoption('%s_1' % choice, '%s Spectators' % choice)
    adminMenuTeam.send(userid)

def All(userid, choice):
    choice = choice.split('_', 1)
    for players in es.getUseridList():
        username = es.getplayername(userid)
        exec '%s(%s, "%s", %s)' % (choice[0], userid, username, players) in globals(), locals()
        
def adminMenuPlayersSelect(userid, choice, poupname):
    choice = choice.split('_', 1)
    exec '%s(%s, "%s", %s)' % (choice[0], userid, es.getplayername(userid), choice[1])
    
def adminMenuTeamSelect(userid, choice, poupname):
    choice = choice.split('_', 1)
    username = es.getplayername(userid)
    for players in filter(lambda x: es.getplayerteam(x) == int(choice[1]), es.getUseridList()):
        exec '%s(%s, "%s", %s)' % (choice[0], userid, username, players) in globals()

def Swap(userid, username, target):
    team = es.getplayerteam(userid)
    gamethread.delayed(0, es.changeteam, (target, getOpponentTeam(team)))
    msg('%s Swapped %s' % (username, es.getplayername(target)))
    
def Kick(userid, username, target):
    es.server.queuecmd('kickid %s' % target)
    msg('%s Kicked %s' % (username, es.getplayername(target)))

def Ban(userid, username, target):
    es.server.queuecmd('ban 5 %s' % target)
    msg('%s Banned %s' % (username, es.getplayername(target)))
    
def adminMenuAdminSelect(userid, choice, popupname):
    global popupAction
    if choice == 1:
        adminMenuUsers = popuplib.easymenu('adminMenuUsers', None, adminMenuUsersSelect)
        adminMenuUsers.settitle('War #GlobalRebellion')
        adminMenuUsers.settitle(':: Players')
        for player in es.getUseridList():
            adminMenuUsers.addoption(player, es.getplayername(player))
        adminMenuUsers.send(userid)
    elif choice == 2:
        adminMenuAdminUsers = popuplib.easymenu('adminMenuAdminUsers', None, adminMenuAdminUsersSelect)
        adminMenuAdminUsers.settitle('War #GlobalRebellion')
        adminMenuAdminUsers.settitle(':: Players')
        for admin in adminList:
            adminMenuAdminUsers.addoption(admin, admin)
        adminMenuAdminUsers.send(userid)
        popupAction = 2
    elif choice == 3:
        adminMenuAdminUsers = popuplib.easymenu('adminMenuAdminUsers', None, adminMenuAdminUsersSelect)
        adminMenuAdminUsers.settitle('War #GlobalRebellion')
        adminMenuAdminUsers.settitle(':: Players')
        for admin in adminList:
            adminMenuAdminUsers.addoption(admin, admin)
        adminMenuAdminUsers.send(userid)
        popupAction = 3
    
def adminMenuUsersSelect(userid, choice, popupname):
    steamid = es.getplayersteamid(choice)
    adminList.append(steamid)
    
def adminMenuAdminUsersSelect(userid, choice, popupname):
    if popupAction == 2:
        adminList.remove(choice)
    elif popupAction == 3:
        tell(userid, 'Check your Console')
        es.cexec(userid, 'echo ')
        es.cexec(userid, 'echo Admins #GlobalRebellion')
        es.cexec(userid, 'echo -----------------------')
        es.cexec(userid, 'echo Steam :: %s' % choice)
        
def adminMenuCommandsSelect(userid, choice, popupname):
    global publicChat
    steamid = es.getplayersteamid(userid)
    if choice == 1:
        es.server.queuecmd('sv_gravity %s' % defaultGravity)
    elif choice == 2:
        if publicChat == 1:
            publicChat = 0
            msg('Public Chat has been DISABLED')
        elif publicChat == 0:
            publicChat = 1
            msg('Public Chat has been ENABLED')
    elif choice == 3:
        changePasswordUser.append(steamid)
        tell(userid, 'Type a #defaultPassword #lightgreento set sv_password.')
        tell(userid, 'Type #defaultNone #lightgreento remove sv_password.')
        tell(userid, 'Type #defaultSame #lightgreento avoid changing sv_password.')
    
'''
Event Scope :: Functions
'''

def player_spawn(ev):
    userid = int(ev['userid'])
    player = playerlib.getPlayer(userid)
    if deathmatch == 1:
        gamethread.delayed(0, player.set, ('health', 612))
    if headshot == 1:
        gamethread.delayed(0, player.set, ('health', 612))
    if knifeOnly == 1:
        es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
        es.server.queuecmd('es_xfire %s player_weaponstrip Strip' % userid)
        es.server.queuecmd('es_xgive %s weapon_knife' % userid)
    
def player_hurt(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    damage = ev['dmg_health']
    hitgroup = int(ev['hitgroup'])
    userhealth = int(ev['health'])
    player = playerlib.getPlayer(userid)
    playerTwo = playerlib.getPlayer(attacker)
    if headshot == 1:
        if hitgroup == 1:
            if damage >= 100:
                es.server.queuecmd('damage %s %s 32 %s' % (userid, userhealth, attacker))
            else:
                player.set('health', 612)
        else:
            player.set('health', 612)
    if deathmatch == 1:
        if userhealth <= 512:
            chosen = random.choice(spawnList)
            es.server.queuecmd('es_xsetpos %s %s' % (userid, chosen))
            player.set('health', 612)
            es.server.queuecmd('score set %s %s' %(attacker, (playerTwo.get('kills') + 1)))
    if oneShot == 1:
        es.server.queuecmd('damage %s %s 32 %s' % (userid, userhealth, attacker))
        
def weapon_zoom(ev):
    if noScope == 1:
        userid = int(ev['userid'])
        es.server.queuecmd('es_cexec %s lastinv' % userid)
        
'''
Filter Scope :: Hooking Commands

'''

def sayFilter(userid, text, teamonly):
    steamid = es.getplayersteamid(userid)
    username = es.getplayername(userid)
    text = text.strip('"')
    if steamid in gravityList:
        es.server.queuecmd('sv_gravity %s' % text)
        msg('A value of %s has been set for GRAVITY' % text)
        gravityList.remove(steamid)
        liveOnThree()
        return (0, text, teamonly)
    if steamid in changePasswordUser:
        if text == "Same" or text == "same":
            changePasswordUser.remove(steamid)
            for admins in adminList:
                if es.getuserid(admins):
                    es.tell(es.getuserid(admins), '#multi', '#green[War] #defaultPassword has #lightgreennot been modified.')
        elif text == "None" or text == "none":
            es.server.queuecmd('sv_password ""')
            changePasswordUser.remove(steamid)
            for admins in adminList:
                if es.getuserid(admins):
                    es.tell(es.getuserid(admins), '#multi', '#green[War] #defaultPassword has been successfully #lightgreenRemoved.')
        else:
            es.server.queuecmd('sv_password %s' % text)
            changePasswordUser.remove(steamid)
            for admins in adminList:
                if es.getuserid(admins):
                    es.tell(es.getuserid(admins), '#multi', '#green[War] #defaultPassword has been successfully #lightgreenChanged to %s.' % text)
        return (0, text, teamonly)
    if publicChat == 1:
        if text.startswith('! '):
            if steamid in adminList:
                if teamonly:
                    for admins in adminList:
                        if es.getuserid(admins):
                            es.tell(es.getuserid(admins), '#multi', '#green[Admin Only] %s: %s' %(username, text[2:]))
                else:
                    es.msg('#multi', '#lightgreen[Admin] %s: %s' %(es.getplayername(userid), text[2:]))
            else:
                es.tell(userid, '[ToAdmin]: %s' % text[2:])
                for admins in adminList:
                    if es.getuserid(admins):
                        es.tell(es.getuserid(admins), '[To Admin] %s: %s' %(username, text[2:]))
            return (0, text, teamonly)
        return (userid, text, teamonly)
    elif publicChat == 0:
        if text.startswith('! '):
            if steamid in adminList:
                if teamonly:
                    for admins in adminList:
                        if es.getuserid(admins):
                            es.tell(es.getuserid(admins), '#multi', '#green[Admin Only] %s: %s' %(username, text[2:]))
                else:
                    es.msg('#multi', '#lightgreen[Admin] %s: %s' %(username, text[2:]))
            else:
                es.tell(userid, '[ToAdmin]: %s' % text[2:])
                for admins in adminList:
                    if es.getuserid(admins):
                        es.tell(es.getuserid(admins), '[To Admin] %s: %s' %(username, text[2:]))
            return (0, text, teamonly)
        elif not text.startswith('! ') and not teamonly and not text == '!admin' and not steamid in changePasswordUser and not steamid in gravityList:
            return (0, text, teamonly)
        return (0, text, teamonly)